<template>
  <div>
    <div style="margin: 3rem">
      <header style="margin:10rem 6rem 0rem 6rem">
        <ReturnButton   :offsetArrow="20" :spanTitle="3" title="Ir a Pedidos" v-on:clickEvent="returnPage" style="margin-bottom:3rem"></ReturnButton>

        <!-- TITULO -->
        <Title Title="REGISTRO DE RECEPCION"> </Title>
      </header>
      <section>
        <div style="margin:5rem 9rem 4rem 9rem">        
          <el-row >
            <el-col :span="6" class="text-orange">
              <h3> PEDIDO N° <span> {{ order.numberOrder}} </span> </h3>
            </el-col>
            <el-col :span="15" class="text-dark-gray-2">
              <h3 v-if="order.orderSupport == 'DISCO OPTICO 1.5 Tb'"> {{ order.orderSupport }}  </h3>
              <h3 v-else> DISCOS {{ order.orderSupport}}  </h3>
            </el-col>
          </el-row>
          <el-row style="margin-top:3rem"> 
            <el-col :span="5">
              <span  style="margin-right: 1.1rem;" class="fonts-bold-general">Pedido Realizado:</span>
            </el-col>
            <el-col :span="3">
              <el-input v-model="order.dateOfOrder" size="small" disabled></el-input>
            </el-col>
          </el-row>
          <el-row style="margin-top:2rem">
            <el-col :span="5">
              <span  style="margin-right: 1.1rem;" class="fonts-bold-general">Cantidad del Pedido:</span>
            </el-col>
            <el-col :span="2">
              <el-input v-model="order.quantity" size="small" disabled></el-input>
            </el-col>
          </el-row>                 
       </div> 
      </section>
      <hr style="margin:3rem 6rem 0rem 6rem"> 

       <section>
        <div style="margin:5rem 9rem 4rem 9rem">        
          <el-row >
            <el-col :span="7" class="text-orange">
              <h3> DETALLE DE LA RECEPCIÓN  </h3>
            </el-col>
          </el-row>
          <el-row style="margin:2rem">
            <el-col :span="5">
              <span  style="margin-right: 1.1rem;" class="fonts-bold-general">Discos Pendientes </span>
            </el-col>
            <el-col :span="2">
              <el-input  size="small" disabled v-model="order.pendientes"></el-input>
            </el-col>
            <el-col :span="5" :offset="1">
              <el-button  @click="addCards" size="small" type="primary" plain v-if="newReceptionShow"> NUEVA RECEPCIÓN </el-button>
            </el-col>
          </el-row>

         <el-row :gutter="80">
          <el-col :span="12" v-for="(text, index ) in receivedCard" :key="index">    
              <el-card class="bg-gray" style="margin:2rem 1rem; height: 230px"  >
                <el-row style="margin: 1.5rem 0;">
                  <el-col :span="10">
                    <h3 class="text-orange">{{ index +1 }}.- RECEPCIÓN: </h3>
                  </el-col>
                </el-row> 

                <el-row style="margin: 0.5rem 2rem">
                  <el-col :span="12">
                    <div class="fonts-bold-general"> Fecha de Llegada </div>
                  </el-col>
                  <el-col :span="12">

                    <el-date-picker 
                     v-model="text.dateArrived"
                type="date"
                format="dd/MM/yyyy"
                size="small"       
                style="width: 100%"
                     >
                    </el-date-picker>
                  </el-col>
                </el-row>

                <el-row style="margin: 0.5rem 2rem">
                  <el-col :span="12">
                    <span  style="margin-right: 1.1rem;" class="fonts-bold-general">Discos Recibidos</span>
                  </el-col>
                  <el-col :span="5">
                    <el-input v-model="text.receivedDiscs" size="small" ></el-input>
                  </el-col>
                </el-row>

              </el-card>
          </el-col>
        </el-row>
       </div>
      </section>     
       <!-- BOTONES DE REGISTRAR Y CANCELAR -->
      <section style="margin:5rem 9rem 4rem 9rem" >      
        <el-row>
          <el-col :span="2" :offset="16">
            <el-button v-on:click="modalCancelButton = true"  type="primary" plain>CANCELAR </el-button>                          
          </el-col>
          <el-col :span="1" :offset="3"> 
            <!--  itemSupport.pendingArrival < 0  -->
            <el-button  @click="enterNewOrder" type="primary" :disabled="order.pendingArrival<0" >REGISTRAR</el-button>  
          </el-col>
        </el-row>
      </section>

     <!-- Modal botón cancelar -->
    <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton"  v-on:btnEvent="returnPage"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger>

      <!-- Modal botón ingresar-->
      <AppModalSuccess :show-dialog.sync="enterSupportModal" v-if="enterSupportModal" 
       :parrafo="'La recepcion del pedido de discos se ha registrado '"
        btn1="VER PEDIDOS" @btnEvent="enterSupportModal = false" v-on:btnEvent="returnPage">
    </AppModalSuccess>

     <!-- Modal botón borrar -->
     <AppModal :show-dialog.sync="eraserOrder"   v-if="eraserOrder" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
      :parrafo="'¿Estas seguro que quieres eliminar la recepción ingresada?'" btn1="SI, ELIMINAR" btn2="CANCELAR" classBtn1="border-red" typeBtn1="danger"
        @btnEvent="deleteCards"
        v-on:eventBtn="eraserOrder = false" >
    </AppModal>
    
     <!-- Modal botón de retroceder RETURNBUTTON -->
    <AppModalDanger parrafo="Si te vas sin guardar, la información se perderá." :show-dialog.sync="modalReturnBtn" v-if="modalReturnBtn"  v-on:btnEvent="returnPage"  @btnEvent="modalReturnBtn = false" v-on:eventBtn="modalCancelButton = false">
    </AppModalDanger> 

    <!-- MODAL cuando exede el numero de discos que falta por recibir -->
    <AppModal :show-dialog.sync="modalExcedent"  v-if="modalExcedent" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="Ingreso Incorrecto" 
      parrafo="La cantidad de discos recibidos, excede el numero de discos pendientes'.">
    </AppModal> 

    </div>
  </div>    
</template>

<script>
  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'
  import { HTTP } from '../../../main.js' 
  import AppModalDanger from '@/components/AppModalDanger.vue'
  import AppModal from '@/components/AppModal.vue'
  import AppModalSuccess from '@/components/AppModalSuccess.vue'

  export default {
    components: {
      ReturnButton,
      Title,
      AppModalDanger,
      AppModalSuccess,
      AppModal
  },
  data() {
    return {
      order:{},
      receivedCard:[],
      templateReceivedCard:{
        dateArrived: '',
        receivedDiscs: 0,
      },

      enterSupportModal: false,
      modalCancelButton: false,
      modalReturnBtn: false,
      modalExcedent: false,
      cardsReception: [ {
        dateArrived: '',
        receivedDiscs: '',
        dateString: '',
        disabledB: false
      } 
     ],
     eraserOrder: false,
     index: null,
     copyCardsReception: {  
        dateArrived: '',
        receivedDiscs: '',
        dateString: '',
        disabledB: false,    
     },
    }
   },
    created() {
      this.order = JSON.parse(localStorage.getItem('objEditSupport'));      
      this.receivedCard = JSON.parse(JSON.stringify(this.order.recived)); 
      if(this.order.stateOrder!=='COMPLETO')
        this.receivedCard.push(this.templateReceivedCard);
    },
    watch:{
      receivedCard: {
        handler: function (val, oldVal) {
          console.log('pasada')
          let count = 0;
          val.forEach(el=>{
            if(!isNaN(parseInt(el.receivedDiscs))){
              count += parseInt(el.receivedDiscs)

            }
          })
          this.order.pendientes = this.order.quantity - count;      
        },
        deep: true
      }
    },
    computed:{
      newReceptionShow(){
        let count = 0;
        let discs = this.receivedCard[this.receivedCard.length - 1].receivedDiscs;      
        return (discs != 0 && discs != '' ) && this.order.pendientes>0
      }
    },
    methods: {
      utilFormatDate(stringDate){
        return new Date(stringDate).toLocaleString("en-GB",{day:'numeric',month:'numeric',year:'numeric'})
      },
      returnPage() {
        this.$router.push({ name: 'ordersPlaced' })
      },
      addCards() {
        let template = JSON.parse(JSON.stringify(this.templateReceivedCard));
        template.receivedDiscs = 0;
        this.receivedCard.push(template);
      },
      deleteCards() {
        this.cardsReception.splice(this.index, 1)
        this.eraserOrder = false
      },
      enterNewOrder() {
        HTTP.patch('supports/received/'+this.order._id,{recived:this.receivedCard})
        .then(res=>this.enterSupportModal = true)
        .catch(console.log) 
      }
    },
  }
</script>

